diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
index 81f896dd7..b3132923d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
@@ -7,129 +7,587 @@ import net.minecraft.client.gui.hud.component.HudComponentMovable;
 import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
+import net.minecraft.client.gui.options.ScreenOptions;
+import net.minecraft.client.gui.options.components.KeyBindingComponent;
+import net.minecraft.client.gui.options.components.OptionsComponent;
+import net.minecraft.client.gui.options.data.OptionsPage;
+import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.option.Option;
-import net.minecraft.client.option.OptionBoolean;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
+import org.lwjgl.input.Keyboard;
 
+import java.awt.*;
 import java.util.ArrayList;
 import java.util.List;
+import java.util.function.Supplier;
 
-public class ScreenHudEditor
-    extends Screen {
-    private static final int BOTTOM_SPACE = 28;
+public class ScreenHudEditor extends Screen {
     private final List<HudComponent> componentsUnderMouse = new ArrayList<>();
+
+    private HudComponent selectedComponent = null;
+    private boolean isDragging = false;
+    private int clickMouseX = 0;
+    private int clickMouseY = 0;
+
     private HudComponent heldComponent = null;
     private ComponentAnchor heldAnchor = ComponentAnchor.TOP_LEFT;
     private HudComponent snappedComponent = null;
     private ComponentAnchor snappedAnchor = null;
-    private float screenPadding = 0.0f;
-    private ButtonElement resetButton;
+    private int nudgeTimer = 0;
+
+    private final List<OptionsComponent> activeContextComponents = new ArrayList<>();
+    private OptionsComponent clickedContextComponent = null;
+    private int clickedContextComponentY = 0;
+    private int contextMenuX, contextMenuY, contextMenuWidth, contextMenuHeight;
+    private ScreenOptions contextOptionsScreen;
+
+    private boolean showOnboarding = false;
 
     public ScreenHudEditor(Screen parent) {
         super(parent);
     }
 
-    private final int BUTTON_ELEMENT_DONE = 0;
-    private final int BUTTON_ELEMENT_RESET = 1;
-
     @Override
     public void init() {
         super.init();
-        this.screenPadding = GameSettings.SCREEN_PADDING.value;
-        GameSettings.SCREEN_PADDING.set(0.0f);
 
-        add(new ButtonElement(BUTTON_ELEMENT_DONE, this.width / 2 - 100, this.height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 178, 20, I18n.getInstance().translateKey("gui.hud_designer.button.done")));
-        add(this.resetButton = new ButtonElement(BUTTON_ELEMENT_RESET, this.width / 2 + 80, this.height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 20, 20, "")
-            .setTextures("minecraft:gui/misc/button_reset", "minecraft:gui/misc/button_reset_highlighted", "minecraft:gui/misc/button_reset"));
+        this.showOnboarding = !GameSettings.SEEN_HUD_EDITOR_ONBOARDING.value;
+
+        OptionsPage contextPage = new OptionsPage("context_menu", null);
+        this.contextOptionsScreen = new ScreenOptions(this, contextPage);
+        this.contextOptionsScreen.opened(this.width, this.height);
+        this.contextOptionsScreen.fontRenderer = this.fontRenderer;
+        this.contextOptionsScreen.width = this.width;
+        this.contextOptionsScreen.height = this.height;
+    }
+
+    @Override
+    public void tick() {
+        super.tick();
+        for (OptionsComponent optionsComponent : this.activeContextComponents) {
+            optionsComponent.tick();
+        }
+
+        if (this.selectedComponent instanceof HudComponentMovable movable && !this.isDragging) {
+            int dx = 0;
+            int dy = 0;
+
+            if (Keyboard.isKeyDown(Keyboard.KEY_UP)) dy = -1;
+            else if (Keyboard.isKeyDown(Keyboard.KEY_DOWN)) dy = 1;
+            else if (Keyboard.isKeyDown(Keyboard.KEY_LEFT)) dx = -1;
+            else if (Keyboard.isKeyDown(Keyboard.KEY_RIGHT)) dx = 1;
+
+            if (dx != 0 || dy != 0) {
+                this.nudgeTimer++;
+                if (this.nudgeTimer > 8) {
+                    nudge(movable, dx, dy);
+                }
+            } else {
+                this.nudgeTimer = 0;
+            }
+        } else {
+            this.nudgeTimer = 0;
+        }
     }
 
     @Override
     public void removed() {
         super.removed();
-        GameSettings.SCREEN_PADDING.set(this.screenPadding);
+        closeContextMenu();
+    }
+
+    private void dismissOnboarding() {
+        this.showOnboarding = false;
+        GameSettings.SEEN_HUD_EDITOR_ONBOARDING.set(true);
+        GameSettings.saveOptions();
+        this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+    }
+
+    private void nudge(HudComponentMovable movable, int dx, int dy) {
+        // Hold Shift to nudge faster
+        if (Keyboard.isKeyDown(GameSettings.KEY_HUD_EDITOR_NUDGE_FAST.getKeyCode())) {
+            dx *= 10;
+            dy *= 10;
+        }
+
+        Layout layout = movable.getLayout();
+
+        if (layout instanceof LayoutAbsolute absoluteLayout) {
+            absoluteLayout.setXOffset(absoluteLayout.getXOffset() + dx);
+            absoluteLayout.setYOffset(absoluteLayout.getYOffset() + dy);
+        }
+        else if (layout instanceof LayoutSnap snapLayout) {
+            snapLayout.setXOffset(snapLayout.getXOffset() + dx);
+            snapLayout.setYOffset(snapLayout.getYOffset() + dy);
+        }
     }
 
     @Override
-    protected void buttonClicked(@NotNull ButtonElement button) {
-        super.buttonClicked(button);
-        if (button.id == BUTTON_ELEMENT_DONE) {
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (this.showOnboarding) {
+            if (eventKey == Keyboard.KEY_RETURN || eventKey == Keyboard.KEY_SPACE || eventKey == Keyboard.KEY_ESCAPE) {
+                dismissOnboarding();
+            }
+            return;
+        }
+
+        if (ScreenOptions.pickingKeyBinding != null) {
+            if (eventKey == Keyboard.KEY_ESCAPE) {
+                ScreenOptions.pickingKeyBinding.unbind();
+            } else {
+                ScreenOptions.pickingKeyBinding.bind(InputDevice.keyboard, eventKey);
+            }
+
+            if (ScreenOptions.pickingKeyBindingComponent != null) {
+                ScreenOptions.pickingKeyBindingComponent.update();
+            }
+
+            ScreenOptions.pickingKeyBinding = null;
+            ScreenOptions.pickingKeyBindingComponent = null;
+            return;
+        }
+
+        // Funnel key presses to the context menu if it is open
+        if (!this.activeContextComponents.isEmpty()) {
+            if (eventKey == Keyboard.KEY_ESCAPE) {
+                closeContextMenu();
+                return;
+            }
+            for (OptionsComponent comp : this.activeContextComponents) {
+                comp.onKeyPress(eventKey, eventCharacter);
+            }
+            return;
+        }
+
+        if (eventKey == GameSettings.KEY_HUD_EDITOR_EXIT.getKeyCode()) {
             this.mc.displayScreen(getParentScreen());
+            this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+            return;
+        }
+
+        if (eventKey == GameSettings.KEY_HUD_EDITOR_ONBOARDING.getKeyCode()) {
+            this.showOnboarding = true;
+            this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+            return;
         }
-        if (button.id == BUTTON_ELEMENT_RESET) {
+
+        if (eventKey == GameSettings.KEY_HUD_EDITOR_RESET.getKeyCode()) {
             HudComponents.INSTANCE.fromSettingsString(HudComponents.DEFAULT_LAYOUT);
             for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
-                if (component.getAttachedOption() != null) {
-                    component.getAttachedOption().resetValueToDefault();
+                for (Option<?> option : component.getRawOptions()) {
+                    option.resetValueToDefault();
                 }
             }
+            this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+            return;
+        }
+
+        // Nudge
+        if (this.selectedComponent instanceof HudComponentMovable movable && !this.isDragging) {
+            int dx = 0;
+            int dy = 0;
+
+            if (eventKey == GameSettings.KEY_HUD_EDITOR_NUDGE_UP.getKeyCode()) dy = -1;
+            else if (eventKey == GameSettings.KEY_HUD_EDITOR_NUDGE_DOWN.getKeyCode()) dy = 1;
+            else if (eventKey == GameSettings.KEY_HUD_EDITOR_NUDGE_LEFT.getKeyCode()) dx = -1;
+            else if (eventKey == GameSettings.KEY_HUD_EDITOR_NUDGE_RIGHT.getKeyCode()) dx = 1;
+
+            if (dx != 0 || dy != 0) {
+                nudge(movable, dx, dy);
+                this.nudgeTimer = 0;
+                return;
+            }
         }
+        super.keyPressed(eventCharacter, eventKey, mx, my);
     }
 
     @Override
     public void mouseClicked(int mx, int my, int buttonNum) {
+        if (this.showOnboarding) {
+            dismissOnboarding();
+            return;
+        }
+
+        if (ScreenOptions.pickingKeyBinding != null) {
+            ScreenOptions.pickingKeyBinding.bind(InputDevice.mouse, buttonNum);
+            if (ScreenOptions.pickingKeyBindingComponent != null) {
+                ScreenOptions.pickingKeyBindingComponent.update();
+                ScreenOptions.pickingKeyBindingComponent = null;
+            }
+            return;
+        }
+
+        // Context Menu Interaction
+        if (!this.activeContextComponents.isEmpty()) {
+            if (mx >= this.contextMenuX && mx <= this.contextMenuX + this.contextMenuWidth &&
+                    my >= this.contextMenuY && my <= this.contextMenuY + this.contextMenuHeight) {
+
+                int currentY = this.contextMenuY + 4;
+                int left = this.contextMenuX + 4;
+                int width = this.contextMenuWidth - 8;
+
+                for (OptionsComponent comp : this.activeContextComponents) {
+                    if (my >= currentY && my <= currentY + comp.getHeight()) {
+                        comp.onMouseClick(buttonNum, left, currentY, width, mx - left, my - currentY);
+                        this.clickedContextComponent = comp;
+                        this.clickedContextComponentY = currentY;
+                        break;
+                    }
+                    currentY += comp.getHeight();
+                }
+                return;
+            } else {
+                closeContextMenu();
+            }
+        }
+
         updateComponentsUnderMouse(mx, my);
         boolean clickedComponent = false;
-        if (buttonNum == 0) {
+
+        // Selection and Dragging
+        if (buttonNum == GameSettings.KEY_HUD_EDITOR_SELECT.getKeyCode()) {
             if (!this.componentsUnderMouse.isEmpty()) {
                 HudComponent componentUnderMouse = this.componentsUnderMouse.get(this.componentsUnderMouse.size() - 1);
+                this.selectedComponent = componentUnderMouse;
+
                 if (componentUnderMouse instanceof HudComponentMovable) {
+                    this.heldComponent = componentUnderMouse;
+                    this.clickMouseX = mx;
+                    this.clickMouseY = my;
+                    this.isDragging = false;
+
                     Layout currentLayout = componentUnderMouse.getLayout();
-                    ComponentAnchor anchor = getClosestAnchor(
-                        currentLayout.getComponentX(componentUnderMouse, this.width),
-                        currentLayout.getComponentY(componentUnderMouse, this.height - BOTTOM_SPACE),
-                        componentUnderMouse, mx, my);
-                    Layout layout = new LayoutAbsolute(0, 0, anchor);
-                    ((HudComponentMovable) componentUnderMouse).setLayout(layout);
+                    this.heldAnchor = getClosestAnchor(
+                            currentLayout.getComponentX(componentUnderMouse, this.width),
+                            currentLayout.getComponentY(componentUnderMouse, this.height),
+                            componentUnderMouse, mx, my);
 
-                    this.heldComponent = componentUnderMouse;
-                    this.heldAnchor = anchor;
                     clickedComponent = true;
+
+                    this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
                 }
             }
         }
-        if (buttonNum == 1) {
+
+        // Open Context Menu
+        if (buttonNum == GameSettings.KEY_HUD_EDITOR_OPEN_CONTEXT.getKeyCode()) {
             if (!this.componentsUnderMouse.isEmpty()) {
                 HudComponent componentUnderMouse = this.componentsUnderMouse.get(this.componentsUnderMouse.size() - 1);
-                Option<?> attachedOption = componentUnderMouse.getAttachedOption();
-                if (attachedOption instanceof OptionBoolean optionBoolean) {
-                    mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
-                    optionBoolean.toggle();
-                }
+                this.selectedComponent = componentUnderMouse;
+
+                List<Supplier<OptionsComponent>> optionSuppliers = componentUnderMouse.getOptionSuppliers();
+                List<Supplier<KeyBindingComponent>> keyBindingSuppliers = componentUnderMouse.getKeyBindingSuppliers();
 
+                boolean hasOptions = optionSuppliers != null && !optionSuppliers.isEmpty();
+                boolean hasKeyBindings = keyBindingSuppliers != null && !keyBindingSuppliers.isEmpty();
+
+                if (hasOptions || hasKeyBindings) {
+                    openContextMenu(componentUnderMouse, mx, my);
+                    clickedComponent = true;
+
+                    this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                }
             }
         }
 
-        if (!clickedComponent) {
+        if (!clickedComponent && buttonNum == 0) {
+            this.selectedComponent = null;
             this.heldComponent = null;
             super.mouseClicked(mx, my, buttonNum);
         }
     }
 
+    private void openContextMenu(HudComponent component, int mx, int my) {
+        this.activeContextComponents.clear();
+
+        // Add Option Components
+        if (component.getOptionSuppliers() != null) {
+            for (Supplier<OptionsComponent> supplier : component.getOptionSuppliers()) {
+                OptionsComponent comp = supplier.get();
+                comp.init(this.mc);
+                this.activeContextComponents.add(comp);
+            }
+        }
+
+        // Add KeyBinding Components (Appended to the end)
+        if (component.getKeyBindingSuppliers() != null) {
+            for (Supplier<KeyBindingComponent> supplier : component.getKeyBindingSuppliers()) {
+                KeyBindingComponent comp = supplier.get();
+                comp.init(this.mc);
+                this.activeContextComponents.add(comp);
+            }
+        }
+
+        // Dynamic Width Parameters
+        int maxTextWidth = 0;
+        int sidePadding = 16;
+        int textControlSpacing = 20;
+        int controlWidth = 150;
+
+        boolean hasContent = false;
+
+        if (component.getRawOptions() != null) {
+            for (Option<?> option : component.getRawOptions()) {
+                hasContent = true;
+                String optionName = I18n.getInstance().translateKey(option.getDisplayStringName());
+                int textWidth = this.fontRenderer.stringWidth(optionName);
+                if (textWidth > maxTextWidth) {
+                    maxTextWidth = textWidth;
+                }
+            }
+        }
+
+        if (component.getRawKeyBindings() != null) {
+            for (KeyBinding keyBinding : component.getRawKeyBindings()) {
+                hasContent = true;
+                controlWidth += 50;
+                String keyName = I18n.getInstance().translateKey(keyBinding.getKeyName());
+                int textWidth = this.fontRenderer.stringWidth(keyName);
+                if (textWidth > maxTextWidth) {
+                    maxTextWidth = textWidth;
+                }
+            }
+        }
+
+        if (hasContent) {
+            this.contextMenuWidth = sidePadding + maxTextWidth + textControlSpacing + controlWidth;
+        } else {
+            this.contextMenuWidth = 200;
+        }
+
+        // Height Calculation
+        int totalHeight = 0;
+        for (OptionsComponent comp : this.activeContextComponents) {
+            totalHeight += comp.getHeight();
+        }
+        this.contextMenuHeight = totalHeight + 8;
+
+        // Positional Logic for placement of the context box
+        boolean isRightHalf = mx > (this.width / 2);
+        boolean isBottomHalf = my > (this.height / 2);
+
+        if (isRightHalf) {
+            this.contextMenuX = mx - this.contextMenuWidth; // Place Left
+        } else {
+            this.contextMenuX = mx; // Place Right
+        }
+
+        if (isBottomHalf) {
+            this.contextMenuY = my - this.contextMenuHeight; // Place Up
+        } else {
+            this.contextMenuY = my; // Place Down
+        }
+
+        // Screen Bounds Clamping
+        if (this.contextMenuX < 0) this.contextMenuX = 0;
+        if (this.contextMenuX + this.contextMenuWidth > this.width) this.contextMenuX = this.width - this.contextMenuWidth;
+        if (this.contextMenuY < 0) this.contextMenuY = 0;
+        if (this.contextMenuY + this.contextMenuHeight > this.height) this.contextMenuY = this.height - this.contextMenuHeight;
+    }
+
+    private void closeContextMenu() {
+        for (OptionsComponent comp : this.activeContextComponents) {
+            comp.onClose();
+        }
+        this.activeContextComponents.clear();
+        this.clickedContextComponent = null;
+    }
+
+    @Override
+    public void mouseReleased(int mx, int my, int buttonNum) {
+        if (this.clickedContextComponent != null) {
+            int left = this.contextMenuX + 4;
+            int width = this.contextMenuWidth - 8;
+            if (buttonNum >= 0) {
+                this.clickedContextComponent.onMouseRelease(buttonNum, left, this.clickedContextComponentY, width, mx - left, my - this.clickedContextComponentY);
+                this.clickedContextComponent = null;
+            } else {
+                this.clickedContextComponent.onMouseMove(left, this.clickedContextComponentY, width, mx - left, my - this.clickedContextComponentY);
+            }
+            return;
+        }
+
+        if (buttonNum == 0) {
+            this.heldComponent = null;
+            this.heldAnchor = null;
+            this.snappedComponent = null;
+            this.snappedAnchor = null;
+            this.isDragging = false;
+        }
+        super.mouseReleased(mx, my, buttonNum);
+    }
+
+    @Override
+    public void render(int mx, int my, float partialTick) {
+        if (!this.activeContextComponents.isEmpty() && this.clickedContextComponent != null) {
+            this.clickedContextComponent.onMouseMove(this.contextMenuX + 4, this.clickedContextComponentY, this.contextMenuWidth - 8, mx - (this.contextMenuX + 4), my - this.clickedContextComponentY);
+        }
+
+        updateComponentsUnderMouse(mx, my);
+
+        if (this.heldComponent != null) {
+            updateHeldComponent(mx, my);
+        }
+
+        renderTexturedBackground();
+        drawHudComponents(mx, my);
+
+        if (this.heldComponent != null && this.isDragging) {
+            for (ComponentAnchor anchor : ComponentAnchor.values()) {
+                if (anchor == ComponentAnchor.CENTER) continue;
+                drawAnchor(0, 0, (int) (this.width * anchor.xPosition), (int) (this.height * anchor.yPosition), anchor);
+            }
+        }
+
+        super.render(mx, my, partialTick);
+
+        if (!this.activeContextComponents.isEmpty()) {
+            drawContextMenu(mx, my);
+        }
+
+        if (ScreenOptions.pickingKeyBinding != null) {
+            GLRenderer.pushFrame();
+            GLRenderer.disableState(State.DEPTH_TEST);
+
+            drawRect(0, 0, this.width, this.height, 0x80000000);
+
+            String actionName = I18n.getInstance().translateKey(ScreenOptions.pickingKeyBinding.getId());
+            String prompt = "Press a key or mouse binding to set it as the keybinding for '" + actionName + "'.";
+
+            drawStringCenteredShadow(this.fontRenderer, prompt, this.width / 2, this.height / 2, 0xFFFFFF);
+
+            GLRenderer.enableState(State.DEPTH_TEST);
+            GLRenderer.popFrame();
+        }
+
+        if (this.showOnboarding) {
+            drawOnboardingOverlay();
+        }
+    }
+
+
+    private void drawOnboardingOverlay() {
+        GLRenderer.pushFrame();
+        GLRenderer.disableState(State.DEPTH_TEST);
+
+        drawRect(0, 0, this.width, this.height, 0xCC000000);
+
+        int boxWidth = 440;
+        int boxHeight = 230;
+        int boxX = (this.width - boxWidth) / 2;
+        int boxY = (this.height - boxHeight) / 2;
+
+        drawRect(boxX, boxY, boxX + boxWidth, boxY + boxHeight, 0xFF222222);
+        drawRect(boxX + 2, boxY + 2, boxX + boxWidth - 2, boxY + boxHeight - 2, 0xFF333333);
+
+        int centerX = this.width / 2;
+
+        TextFormatting gold = TextFormatting.ORANGE;
+        TextFormatting white = TextFormatting.WHITE;
+        TextFormatting yellow = TextFormatting.YELLOW;
+        TextFormatting gray = TextFormatting.GRAY;
+
+        I18n i18n = I18n.getInstance();
+
+        drawStringCenteredShadow(this.fontRenderer, gold + i18n.translateKey("gui.options.hudeditor.onboarding.welcome"), centerX, boxY + 15, 0xFFFFFF);
+
+        int startY = boxY + 45;
+        int lineSpacing = 16;
+
+        String select     = GameSettings.KEY_HUD_EDITOR_SELECT.getKeyName();
+        String context    = GameSettings.KEY_HUD_EDITOR_OPEN_CONTEXT.getKeyName();
+        String nudgeUp    = GameSettings.KEY_HUD_EDITOR_NUDGE_UP.getKeyName();
+        String nudgeDown  = GameSettings.KEY_HUD_EDITOR_NUDGE_DOWN.getKeyName();
+        String nudgeLeft  = GameSettings.KEY_HUD_EDITOR_NUDGE_LEFT.getKeyName();
+        String nudgeRight = GameSettings.KEY_HUD_EDITOR_NUDGE_RIGHT.getKeyName();
+        String fast       = GameSettings.KEY_HUD_EDITOR_NUDGE_FAST.getKeyName();
+        String reset      = GameSettings.KEY_HUD_EDITOR_RESET.getKeyName();
+        String onboarding = GameSettings.KEY_HUD_EDITOR_ONBOARDING.getKeyName();
+        String exit       = GameSettings.KEY_HUD_EDITOR_EXIT.getKeyName();
+
+        String arrowKeys = nudgeUp + "/" + nudgeDown + "/" + nudgeLeft + "/" + nudgeRight;
+
+        drawStringCenteredShadow(this.fontRenderer, white + String.format(i18n.translateKey("gui.options.hudeditor.onboarding.select"), yellow + select + white), centerX, startY, 0xFFFFFF);
+        drawStringCenteredShadow(this.fontRenderer, white + String.format(i18n.translateKey("gui.options.hudeditor.onboarding.drag"), yellow + select + white), centerX, startY + lineSpacing, 0xFFFFFF);
+        drawStringCenteredShadow(this.fontRenderer, white + String.format(i18n.translateKey("gui.options.hudeditor.onboarding.context"), yellow + context + white), centerX, startY + (lineSpacing * 2), 0xFFFFFF);
+        drawStringCenteredShadow(this.fontRenderer, white + String.format(i18n.translateKey("gui.options.hudeditor.onboarding.nudge"), yellow + arrowKeys + white), centerX, startY + (lineSpacing * 3), 0xFFFFFF);
+        drawStringCenteredShadow(this.fontRenderer, white + String.format(i18n.translateKey("gui.options.hudeditor.onboarding.nudge_fast"), yellow + fast + white), centerX, startY + (lineSpacing * 4), 0xFFFFFF);
+        drawStringCenteredShadow(this.fontRenderer, white + String.format(i18n.translateKey("gui.options.hudeditor.onboarding.reset"), yellow + reset + white), centerX, startY + (lineSpacing * 5), 0xFFFFFF);
+        drawStringCenteredShadow(this.fontRenderer, white + String.format(i18n.translateKey("gui.options.hudeditor.onboarding.exit"), yellow + exit + white), centerX, startY + (lineSpacing * 6), 0xFFFFFF);
+
+        drawStringCenteredShadow(this.fontRenderer, gray + String.format(i18n.translateKey("gui.options.hudeditor.onboarding.reopen"), yellow + onboarding + gray), centerX, startY + (lineSpacing * 8), 0xFFFFFF);
+
+        int alpha = (int) (Math.abs(Math.sin(System.currentTimeMillis() % 2000 / 2000.0 * Math.PI)) * 245) + 10;
+        int promptColor = (alpha << 24) | 0xAAAAAA;
+
+        drawStringCenteredShadow(this.fontRenderer, i18n.translateKey("gui.options.hudeditor.onboarding.begin"), centerX, boxY + boxHeight - 20, promptColor);
+
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.popFrame();
+    }
+
+    private void drawContextMenu(int mouseX, int mouseY) {
+        int minX = this.contextMenuX;
+        int maxX = this.contextMenuX + this.contextMenuWidth;
+        int minY = this.contextMenuY;
+        int maxY = this.contextMenuY + this.contextMenuHeight;
+
+        GLRenderer.pushFrame();
+        GLRenderer.disableState(State.DEPTH_TEST);
+
+        drawRect(minX, minY, maxX, maxY, 0xFF222222);
+        drawRect(minX + 2, minY + 2, maxX - 2, maxY - 2, 0xFF333333);
+
+        int currentY = this.contextMenuY + 4;
+        int left = this.contextMenuX + 4;
+        int width = this.contextMenuWidth - 8;
+
+        for (OptionsComponent optionsComponent : this.activeContextComponents) {
+            optionsComponent.render(this.contextOptionsScreen, left, currentY, width, mouseX - left, mouseY - currentY);
+            currentY += optionsComponent.getHeight();
+        }
+
+        GLRenderer.popFrame();
+    }
+
     private void updateHeldComponent(int mouseX, int mouseY) {
         if (this.heldComponent == null) return;
 
-        int xSize = this.heldComponent.getXSize();
-        int ySize = this.heldComponent.getYSize();
-        int xOffset = this.heldComponent.getAnchorX(this.heldAnchor);
-        int yOffset = this.heldComponent.getAnchorY(this.heldAnchor);
+        if (!this.isDragging) {
+            if (Math.abs(mouseX - this.clickMouseX) > 3 || Math.abs(mouseY - this.clickMouseY) > 3) {
+                this.isDragging = true;
+                closeContextMenu(); // Cancel menu if dragging starts
+                Layout layout = new LayoutAbsolute(0, 0, this.heldAnchor);
+                ((HudComponentMovable) this.heldComponent).setLayout(layout);
+            } else {
+                return;
+            }
+        }
+
+        int xSize = this.heldComponent.getDisplayedXSize();
+        int ySize = this.heldComponent.getDisplayedYSize();
+        int xOffset = this.heldComponent.getDisplayedAnchorX(this.heldAnchor);
+        int yOffset = this.heldComponent.getDisplayedAnchorY(this.heldAnchor);
         int newX = MathHelper.clamp(mouseX, xOffset, this.width - (xSize - xOffset));
-        int newY = MathHelper.clamp(mouseY, yOffset, this.height - BOTTOM_SPACE - (ySize - yOffset));
+        int newY = MathHelper.clamp(mouseY, yOffset, this.height - (ySize - yOffset));
 
         Layout layout = this.heldComponent.getLayout();
         if (layout instanceof LayoutAbsolute absoluteLayout) {
             absoluteLayout.setXPosition((float) newX / this.width);
-            absoluteLayout.setYPosition((float) newY / (this.height - BOTTOM_SPACE));
+            absoluteLayout.setYPosition((float) newY / this.height);
         }
 
-        // Snap to other components
         int snapRadius = 10;
         boolean didSnap = false;
         for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
@@ -155,26 +613,20 @@ public class ScreenHudEditor
             if (isNested) continue;
 
             int x = otherLayout.getComponentX(component, this.width);
-            int y = otherLayout.getComponentY(component, this.height - BOTTOM_SPACE);
-
-            // Get mouse distance
-            int mouseDistance = (int) Math.sqrt(Math.pow(mouseX - newX, 2) + Math.pow(mouseY - newY, 2));
-
-            if (mouseDistance < 10) {
-                ComponentAnchor anchor = getAnchorInRadius(x, y, component, newX, newY, snapRadius);
-                if (anchor != null && this.heldAnchor.canConnectTo(anchor)) {
-                    this.snappedComponent = component;
-                    this.snappedAnchor = anchor;
-                    LayoutSnap newLayout = new LayoutSnap(component, anchor, this.heldAnchor);
-                    ((HudComponentMovable) this.heldComponent).setLayout(newLayout);
-                    didSnap = true;
-                    break;
-                }
+            int y = otherLayout.getComponentY(component, this.height);
+
+            ComponentAnchor anchor = getAnchorInRadius(x, y, component, newX, newY, snapRadius);
+            if (anchor != null && this.heldAnchor.canConnectTo(anchor)) {
+                this.snappedComponent = component;
+                this.snappedAnchor = anchor;
+                LayoutSnap newLayout = new LayoutSnap(component, anchor, this.heldAnchor);
+                ((HudComponentMovable) this.heldComponent).setLayout(newLayout);
+                didSnap = true;
+                break;
             }
         }
 
         if (!didSnap) {
-            // Try screen-edge snapping
             snapRadius = 20;
             ComponentAnchor anchor = getScreenAnchorInRadius(0, 0, newX, newY, snapRadius);
             if (anchor != null) {
@@ -186,7 +638,7 @@ public class ScreenHudEditor
             }
 
             if (!didSnap) {
-                LayoutAbsolute newLayout = new LayoutAbsolute((float) newX / this.width, (float) newY / (this.height - BOTTOM_SPACE), this.heldAnchor);
+                LayoutAbsolute newLayout = new LayoutAbsolute((float) newX / this.width, (float) newY / this.height, this.heldAnchor);
                 ((HudComponentMovable) this.heldComponent).setLayout(newLayout);
                 this.snappedComponent = null;
                 this.snappedAnchor = null;
